Index: /exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/ShaopPartyTest.java
===================================================================
--- /exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/ShaopPartyTest.java	(revision 10)
+++ /exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/ShaopPartyTest.java	(revision 10)
@@ -0,0 +1,251 @@
+package geniusweb.exampleparties.simpleshaop;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertNotNull;
+import static org.junit.Assert.assertTrue;
+import static org.mockito.Matchers.eq;
+import static org.mockito.Mockito.mock;
+import static org.mockito.Mockito.verify;
+
+import java.io.IOException;
+import java.net.URI;
+import java.net.URISyntaxException;
+import java.nio.charset.StandardCharsets;
+import java.nio.file.Files;
+import java.nio.file.Paths;
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+import java.util.logging.Level;
+
+import org.junit.Before;
+import org.junit.Ignore;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.Accept;
+import geniusweb.actions.Action;
+import geniusweb.actions.ElicitComparison;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.Offer;
+import geniusweb.actions.PartyId;
+import geniusweb.connection.ConnectionEnd;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.Value;
+import geniusweb.party.Capabilities;
+import geniusweb.party.inform.ActionDone;
+import geniusweb.party.inform.Finished;
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.Settings;
+import geniusweb.party.inform.YourTurn;
+import geniusweb.profile.Profile;
+import geniusweb.progress.ProgressRounds;
+import geniusweb.references.Parameters;
+import geniusweb.references.ProfileRef;
+import geniusweb.references.ProtocolRef;
+import geniusweb.references.Reference;
+import tudelft.utilities.listener.DefaultListenable;
+import tudelft.utilities.logging.Reporter;
+
+public class ShaopPartyTest {
+
+	private static final String SHAOP = "SHAOP";
+	private static final PartyId otherparty = new PartyId("other");
+	private static final String PROFILE = "src/test/resources/testprofile.json";
+	private final static ObjectMapper jackson = new ObjectMapper();
+
+	private ShaopParty party;
+	private final TestConnection connection = new TestConnection();
+	private final ProtocolRef protocol = mock(ProtocolRef.class);
+	private final ProgressRounds progress = mock(ProgressRounds.class);
+	private Settings settings;
+	private Profile profile;
+	private final Parameters parameters = new Parameters();
+
+	@Before
+	public void before() throws JsonParseException, JsonMappingException,
+			IOException, URISyntaxException {
+		party = new ShaopParty();
+		settings = new Settings(new PartyId("party1"),
+				new ProfileRef(new URI("file:" + PROFILE)), protocol, progress,
+				parameters);
+
+		String serialized = new String(Files.readAllBytes(Paths.get(PROFILE)),
+				StandardCharsets.UTF_8);
+		profile = jackson.readValue(serialized, Profile.class);
+
+	}
+
+	@Test
+	public void smokeTest() {
+	}
+
+	@Test
+	public void getDescriptionTest() {
+		assertNotNull(party.getDescription());
+	}
+
+	@Test
+	public void getCapabilitiesTest() {
+		Capabilities capabilities = party.getCapabilities();
+		assertFalse("party does not define protocols",
+				capabilities.getBehaviours().isEmpty());
+	}
+
+	@Test
+	public void testInformConnection() {
+		party.connect(connection);
+		// agent should not start acting just after an inform
+		assertEquals(0, connection.getActions().size());
+	}
+
+	@Test
+	public void testInformSettings() {
+		party.connect(connection);
+		connection.notifyListeners(settings);
+		assertEquals(0, connection.getActions().size());
+	}
+
+	@Test
+	public void testInformAndConnection() {
+		party.connect(connection);
+		party.notifyChange(settings);
+		assertEquals(0, connection.getActions().size());
+	}
+
+	@Test
+	public void testOtherWalksAway() {
+		party.connect(connection);
+		party.notifyChange(settings);
+
+		party.notifyChange(new ActionDone(new EndNegotiation(otherparty)));
+
+		// party should not act at this point
+		assertEquals(0, connection.getActions().size());
+	}
+
+	@Test
+	public void testAgentHasFirstTurn() {
+		party.connect(connection);
+		party.notifyChange(settings);
+
+		party.notifyChange(new YourTurn());
+		assertEquals(1, connection.getActions().size());
+		assertTrue(connection.getActions().get(0) instanceof Offer);
+	}
+
+	@Test
+	public void testAgentElicitsComparison() {
+		party.connect(connection);
+		party.notifyChange(settings);
+
+		Bid bid = makeBid("3", "3"); // not yet in profile
+		party.notifyChange(new ActionDone(new Offer(otherparty, bid)));
+		party.notifyChange(new YourTurn());
+		assertEquals(1, connection.getActions().size());
+		assertTrue(connection.getActions().get(0) instanceof ElicitComparison);
+
+	}
+
+	@Ignore
+	@Test
+	public void testAgentAccepts() {
+		// to make agent accept, the offered bid must score >0.9
+		// we would need to mock a lot t make that happen
+		// as we need to place >10 comparable bids for that.
+		party.connect(connection);
+		party.notifyChange(settings);
+
+		Bid bid = makeBid("1", "1");// best pssible
+		party.notifyChange(new ActionDone(new Offer(otherparty, bid)));
+		party.notifyChange(new YourTurn());
+		assertEquals(1, connection.getActions().size());
+		assertTrue(connection.getActions().get(0) instanceof Accept);
+
+	}
+
+	@Test
+	public void testAgentLogsFinal() {
+		// this log output is optional, this is to show how to check log
+		Reporter reporter = mock(Reporter.class);
+		party = new ShaopParty(reporter);
+		party.connect(connection);
+		party.notifyChange(settings);
+		party.notifyChange(new Finished(null));
+
+		verify(reporter).log(eq(Level.INFO),
+				eq("Final ourcome:Finished[null]"));
+	}
+
+	@Test
+	public void testAgentsUpdatesProgress() {
+		party.connect(connection);
+		party.notifyChange(settings);
+
+		party.notifyChange(new ActionDone(new Offer(null, mock(Bid.class))));
+
+		party.notifyChange(new YourTurn());
+		verify(progress).advance();
+	}
+
+	@Test
+	public void testGetCapabilities() {
+		assertTrue(party.getCapabilities().getBehaviours().contains(SHAOP));
+	}
+
+	private Bid makeBid(String val1, String val2) {
+		Map<String, Value> map = new HashMap<>();
+		map.put("iss1", new DiscreteValue(val1));
+		map.put("iss2", new DiscreteValue(val2));
+		return new Bid(map);
+
+	}
+
+}
+
+/**
+ * A "real" connection object, because the party is going to subscribe etc, and
+ * without a real connection we would have to do a lot of mocks that would make
+ * the test very hard to read.
+ *
+ */
+class TestConnection extends DefaultListenable<Inform>
+		implements ConnectionEnd<Inform, Action> {
+	private List<Action> actions = new LinkedList<>();
+
+	@Override
+	public void send(Action action) throws IOException {
+		actions.add(action);
+	}
+
+	@Override
+	public Reference getReference() {
+		return null;
+	}
+
+	@Override
+	public URI getRemoteURI() {
+		return null;
+	}
+
+	@Override
+	public void close() {
+
+	}
+
+	@Override
+	public Error getError() {
+		return null;
+	}
+
+	public List<Action> getActions() {
+		return actions;
+	}
+
+}
Index: /exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrderingTest.java
===================================================================
--- /exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrderingTest.java	(revision 10)
+++ /exampleparties/simpleshaop/src/test/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrderingTest.java	(revision 10)
@@ -0,0 +1,120 @@
+package geniusweb.exampleparties.simpleshaop;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertTrue;
+import static org.mockito.Mockito.mock;
+import static org.mockito.Mockito.when;
+
+import java.math.BigDecimal;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.Domain;
+import geniusweb.profile.DefaultPartialOrdering;
+
+public class SimpleLinearOrderingTest {
+	private DefaultPartialOrdering realprofile = mock(
+			DefaultPartialOrdering.class);;
+	private Domain domain = mock(Domain.class);
+	private SimpleLinearOrdering estprofile;
+	private Bid bid1 = makeBid(1);
+	private Bid bid2 = makeBid(2);
+	private Bid bid3 = makeBid(3);
+	private Bid bid4 = makeBid(4);
+	private final List<Bid> emptyList = Collections.emptyList();
+
+	@Before
+	public void before() {
+		when(realprofile.getDomain()).thenReturn(domain);
+		estprofile = new SimpleLinearOrdering(realprofile);
+		when(bid1.toString()).thenReturn("bid1");
+
+	}
+
+	private static Bid makeBid(int n) {
+		Bid mockbid = mock(Bid.class);
+		when(mockbid.toString()).thenReturn("bid " + n);
+		return mockbid;
+	}
+
+	@Test
+	public void testSmoke() {
+	}
+
+	@Test
+	public void testInitialBids() {
+		assertTrue(estprofile.getBids().isEmpty());
+	}
+
+	@Test
+	public void largerInitialListTest() {
+		when(realprofile.getBids()).thenReturn(Arrays.asList(bid1, bid2, bid3));
+		// idea is that 3 > 2 > 1
+		when(realprofile.isPreferredOrEqual(bid2, bid1)).thenReturn(true);
+		when(realprofile.isPreferredOrEqual(bid1, bid2)).thenReturn(false);
+		when(realprofile.isPreferredOrEqual(bid3, bid2)).thenReturn(true);
+		when(realprofile.isPreferredOrEqual(bid2, bid3)).thenReturn(false);
+		when(realprofile.isPreferredOrEqual(bid3, bid1)).thenReturn(true);
+		when(realprofile.isPreferredOrEqual(bid1, bid3)).thenReturn(false);
+		SimpleLinearOrdering testprofile = new SimpleLinearOrdering(
+				realprofile);
+		assertEquals(Arrays.asList(bid3, bid2, bid1), testprofile.getBids());
+	}
+
+	@Test
+	public void testAddFirstBid() {
+		SimpleLinearOrdering prof1 = estprofile.with(bid1,
+				Collections.emptyList());
+
+		assertEquals(1, prof1.getBids().size());
+	}
+
+	@Test
+	public void testAddTwoBidsSecondIsWorse() {
+		SimpleLinearOrdering prof1 = estprofile.with(bid1, emptyList);
+		// new bid is worse as bid1, so list of worse bids is empty
+		SimpleLinearOrdering prof2 = prof1.with(bid2, emptyList);
+
+		assertEquals(Arrays.asList(bid2, bid1), prof2.getBids());
+	}
+
+	@Test
+	public void testAddTwoBidsSecondIsBetter() {
+		SimpleLinearOrdering prof1 = estprofile.with(bid1, emptyList);
+		SimpleLinearOrdering prof2 = prof1.with(bid2, Arrays.asList(bid1));
+
+		assertEquals(Arrays.asList(bid1, bid2), prof2.getBids());
+	}
+
+	@Test
+	public void testAddThreeBidsThirdIsMiddle() {
+		SimpleLinearOrdering prof1 = new SimpleLinearOrdering(domain,
+				Arrays.asList(bid1, bid2));
+		SimpleLinearOrdering prof2 = prof1.with(bid3, Arrays.asList(bid1));
+
+		assertEquals(Arrays.asList(bid1, bid3, bid2), prof2.getBids());
+	}
+
+	@Test
+	public void getUtilityTest3Bids() {
+		SimpleLinearOrdering prof1 = new SimpleLinearOrdering(domain,
+				Arrays.asList(bid1, bid3, bid2));
+
+		assertEquals(new BigDecimal("0.50000000"), prof1.getUtility(bid3));
+	}
+
+	@Test
+	public void getUtilityTest4Bids() {
+		// with 4 bids, we get utility 1/3 which causes deximal expansiion issue
+		SimpleLinearOrdering prof1 = new SimpleLinearOrdering(domain,
+				Arrays.asList(bid1, bid2, bid3, bid4));
+
+		assertEquals(new BigDecimal("0.33333333"), prof1.getUtility(bid2));
+	}
+
+}
Index: /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/ExtendedUtilSpace.java
===================================================================
--- /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/ExtendedUtilSpace.java	(revision 9)
+++ /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/ExtendedUtilSpace.java	(revision 10)
@@ -11,5 +11,5 @@
 import geniusweb.issuevalue.Bid;
 import geniusweb.issuevalue.Value;
-import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
+import geniusweb.profile.utilityspace.LinearAdditive;
 import tudelft.utilities.immutablelist.ImmutableList;
 
@@ -20,5 +20,5 @@
  */
 public class ExtendedUtilSpace {
-	private LinearAdditiveUtilitySpace utilspace;
+	private LinearAdditive utilspace;
 	private BigDecimal tolerance; // utility tolerance for a bid.
 	private BidsWithUtility bidutils;
@@ -27,5 +27,5 @@
 	private BigDecimal maxUtil;
 
-	public ExtendedUtilSpace(LinearAdditiveUtilitySpace space) {
+	public ExtendedUtilSpace(LinearAdditive space) {
 		this.utilspace = space;
 		bidutils = new BidsWithUtility(utilspace);
Index: /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java
===================================================================
--- /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 9)
+++ /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 10)
@@ -4,6 +4,4 @@
 import java.math.BigDecimal;
 import java.math.BigInteger;
-import java.net.URI;
-import java.net.URISyntaxException;
 import java.util.Arrays;
 import java.util.HashSet;
@@ -24,10 +22,9 @@
 import geniusweb.party.inform.YourTurn;
 import geniusweb.profile.Profile;
-import geniusweb.profile.utilityspace.LinearAdditiveUtilitySpace;
+import geniusweb.profile.utilityspace.LinearAdditive;
 import geniusweb.profileconnection.ProfileConnectionFactory;
 import geniusweb.profileconnection.ProfileInterface;
 import geniusweb.progress.Progress;
 import geniusweb.progress.ProgressRounds;
-import geniusweb.references.ProtocolRef;
 import tudelft.utilities.immutablelist.ImmutableList;
 import tudelft.utilities.logging.Reporter;
@@ -44,5 +41,5 @@
 	private static final BigDecimal DEC100 = new BigDecimal("100");
 	private ProfileInterface profileint;
-	private LinearAdditiveUtilitySpace utilspace = null; // last received space
+	private LinearAdditive utilspace = null; // last received space
 	private PartyId me;
 	private Progress progress;
@@ -61,12 +58,5 @@
 	@Override
 	public Capabilities getCapabilities() {
-		try {
-			return new Capabilities(new HashSet<>(
-					Arrays.asList(new ProtocolRef(new URI("SAOP")))));
-		} catch (URISyntaxException e) {
-			getReporter().log(Level.SEVERE, "Failed to create capabilities URI",
-					e);
-			return null;
-		}
+		return new Capabilities(new HashSet<>(Arrays.asList("SAOP")));
 	}
 
@@ -148,8 +138,8 @@
 	}
 
-	private LinearAdditiveUtilitySpace updateUtilSpace() {
+	private LinearAdditive updateUtilSpace() throws IOException {
 		Profile newutilspace = profileint.getProfile();
 		if (!newutilspace.equals(utilspace)) {
-			utilspace = (LinearAdditiveUtilitySpace) newutilspace;
+			utilspace = (LinearAdditive) newutilspace;
 			extendedspace = new ExtendedUtilSpace(utilspace);
 		}
Index: /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java
===================================================================
--- /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java	(revision 9)
+++ /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java	(revision 10)
@@ -53,5 +53,5 @@
 public class TimeDependentPartyTest {
 
-	private static final ProtocolRef SAOP = new ProtocolRef("SAOP");
+	private static final String SAOP = "SAOP";
 	private static final PartyId otherparty = new PartyId("other");
 	private static final String PROFILE = "src/test/resources/testprofile.json";
@@ -105,5 +105,5 @@
 		Capabilities capabilities = party.getCapabilities();
 		assertFalse("party does not define protocols",
-				capabilities.getProtocols().isEmpty());
+				capabilities.getBehaviours().isEmpty());
 	}
 
@@ -198,5 +198,5 @@
 	@Test
 	public void testGetCapabilities() {
-		assertTrue(party.getCapabilities().getProtocols().contains(SAOP));
+		assertTrue(party.getCapabilities().getBehaviours().contains(SAOP));
 	}
 
Index: /party/src/main/java/geniusweb/party/Capabilities.java
===================================================================
--- /party/src/main/java/geniusweb/party/Capabilities.java	(revision 9)
+++ /party/src/main/java/geniusweb/party/Capabilities.java	(revision 10)
@@ -5,7 +5,4 @@
 import com.fasterxml.jackson.annotation.JsonAutoDetect;
 import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
-
-import geniusweb.references.ProtocolRef;
-
 import com.fasterxml.jackson.annotation.JsonCreator;
 import com.fasterxml.jackson.annotation.JsonProperty;
@@ -19,5 +16,5 @@
 	 * List of supported protocols
 	 */
-	private final Set<ProtocolRef> protocols;
+	private final Set<String> behaviours;
 
 	/**
@@ -26,13 +23,13 @@
 	 */
 	@JsonCreator
-	public Capabilities(@JsonProperty("protocols") Set<ProtocolRef> protocols) {
-		if (protocols == null) {
-			throw new IllegalArgumentException("protocols==null");
+	public Capabilities(@JsonProperty("behaviours") Set<String> behaviours) {
+		if (behaviours == null) {
+			throw new IllegalArgumentException("behaviours==null");
 		}
-		this.protocols = protocols;
+		this.behaviours = behaviours;
 	}
 
-	public Set<ProtocolRef> getProtocols() {
-		return protocols;
+	public Set<String> getBehaviours() {
+		return behaviours;
 	}
 
@@ -42,5 +39,5 @@
 		int result = 1;
 		result = prime * result
-				+ ((protocols == null) ? 0 : protocols.hashCode());
+				+ ((behaviours == null) ? 0 : behaviours.hashCode());
 		return result;
 	}
@@ -55,8 +52,8 @@
 			return false;
 		Capabilities other = (Capabilities) obj;
-		if (protocols == null) {
-			if (other.protocols != null)
+		if (behaviours == null) {
+			if (other.behaviours != null)
 				return false;
-		} else if (!protocols.equals(other.protocols))
+		} else if (!behaviours.equals(other.behaviours))
 			return false;
 		return true;
@@ -65,5 +62,5 @@
 	@Override
 	public String toString() {
-		return "Capabilities[" + "Protocols=" + protocols + "]";
+		return "Capabilities[" + "Behaviours=" + behaviours + "]";
 	}
 
Index: /party/src/test/java/geniusweb/party/CapabilitiesTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/CapabilitiesTest.java	(revision 9)
+++ /party/src/test/java/geniusweb/party/CapabilitiesTest.java	(revision 10)
@@ -4,5 +4,4 @@
 
 import java.io.IOException;
-import java.net.URI;
 import java.net.URISyntaxException;
 import java.util.Arrays;
@@ -18,6 +17,4 @@
 import com.fasterxml.jackson.databind.ObjectMapper;
 
-import geniusweb.party.Capabilities;
-import geniusweb.references.ProtocolRef;
 import tudelft.utilities.junit.GeneralTests;
 
@@ -26,16 +23,12 @@
 	private Capabilities capabilities1, capabilities1a, capabilities2,
 			capabilities3;
-	private String asJson = "{\"protocols\":[\"ws:localhost/protocol1\"]}";
+	private String asJson = "{\"behaviours\":[\"SAOP\"]}";
 
 	@Before
 	public void before() throws URISyntaxException {
-		capabilities1 = new Capabilities(Sets
-				.newSet(new ProtocolRef(new URI("ws:localhost/protocol1"))));
-		capabilities1a = new Capabilities(Sets
-				.newSet(new ProtocolRef(new URI("ws:localhost/protocol1"))));
-		capabilities2 = new Capabilities(Sets
-				.newSet(new ProtocolRef(new URI("ws:localhost/protocol2"))));
-		capabilities3 = new Capabilities(Sets
-				.newSet(new ProtocolRef(new URI("ws:localhost/protocol3"))));
+		capabilities1 = new Capabilities(Sets.newSet("SAOP"));
+		capabilities1a = new Capabilities(Sets.newSet("SAOP"));
+		capabilities2 = new Capabilities(Sets.newSet("SEB"));
+		capabilities3 = new Capabilities(Sets.newSet("SEB", "SAOP"));
 	}
 
@@ -48,8 +41,7 @@
 	@Override
 	public List<String> getGeneralTestStrings() {
-		return Arrays.asList(
-				"Capabilities.*Protocols=.*ProtocolRef.*protocol1.*",
-				"Capabilities.*Protocols=.*ProtocolRef.*protocol2.*",
-				"Capabilities.*Protocols=.*ProtocolRef.*protocol3.*");
+		return Arrays.asList("Capabilities.*Behaviours=.*SAOP.*",
+				"Capabilities.*Behaviours=.*SEB.*",
+				"Capabilities.*Behaviours=.*SEB.*SAOP.*");
 	}
 
Index: /profile/src/main/java/geniusweb/profile/DefaultPartialOrdering.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/DefaultPartialOrdering.java	(revision 9)
+++ /profile/src/main/java/geniusweb/profile/DefaultPartialOrdering.java	(revision 10)
@@ -26,5 +26,6 @@
  * limited anyway.
  */
-public class DefaultPartialOrdering extends DefaultProfile implements PartialOrdering {
+public class DefaultPartialOrdering extends DefaultProfile
+		implements PartialOrdering {
 
 	/**
@@ -40,10 +41,13 @@
 	 * @param reservationbid
 	 * @param bids
-	 * @param isbetterList   a list of tuples [bid1index, bid2index]. It indicates
-	 *                       that bids[bid1index] isbetterthan bids[bid2index].
+	 * @param isbetterList   a list of tuples [bid1index, bid2index]. It
+	 *                       indicates that bids[bid1index] isbetterthan
+	 *                       bids[bid2index].
 	 */
 	@JsonCreator
-	public DefaultPartialOrdering(@JsonProperty("name") String name, @JsonProperty("domain") Domain domain,
-			@JsonProperty("reservationBid") Bid reservationbid, @JsonProperty("bids") List<Bid> bids,
+	public DefaultPartialOrdering(@JsonProperty("name") String name,
+			@JsonProperty("domain") Domain domain,
+			@JsonProperty("reservationBid") Bid reservationbid,
+			@JsonProperty("bids") List<Bid> bids,
 			@JsonProperty("better") List<List<Integer>> isbetterList) {
 		this(name, domain, reservationbid, makeBidMap(bids, isbetterList));
@@ -54,8 +58,9 @@
 	 * @param domain         the {@link Domain} description
 	 * @param reservationbid the reservation {@link Bid}
-	 * @param isBetterMap    a map with keys = a better bid and value=a less good
-	 *                       bid.
+	 * @param isBetterMap    a map with keys = a better bid and value=a less
+	 *                       good bid.
 	 */
-	public DefaultPartialOrdering(String name, Domain domain, Bid reservationbid, Map<Bid, Set<Bid>> isBetterMap) {
+	public DefaultPartialOrdering(String name, Domain domain,
+			Bid reservationbid, Map<Bid, Set<Bid>> isBetterMap) {
 		super(name, domain, reservationbid);
 		this.isBetter = isBetterMap;
@@ -71,5 +76,6 @@
 	/**
 	 * 
-	 * @return a list with all the bids
+	 * @return a list with all the bids that are referred to, either as better
+	 *         or as worse than another bid
 	 */
 	@JsonGetter
@@ -97,5 +103,6 @@
 			if (isBetter.containsKey(bid)) {
 				for (Bid worsebid : isBetter.get(bid)) {
-					betterlist.add(Arrays.asList(bidslist.indexOf(bid), bidslist.indexOf(worsebid)));
+					betterlist.add(Arrays.asList(bidslist.indexOf(bid),
+							bidslist.indexOf(worsebid)));
 				}
 			}
@@ -107,13 +114,16 @@
 	@Override
 	public String toString() {
-		return "DefaultPartialOrdering[" + getValuesString() + "," + isBetter + "]";
+		return "DefaultPartialOrdering[" + getValuesString() + "," + isBetter
+				+ "]";
 	}
 
-	private static Map<Bid, Set<Bid>> makeBidMap(List<Bid> bids, List<List<Integer>> isBetterList) {
+	private static Map<Bid, Set<Bid>> makeBidMap(List<Bid> bids,
+			List<List<Integer>> isBetterList) {
 		Map<Bid, Set<Bid>> betterMap = new HashMap<>();
 
 		for (List<Integer> tuple : isBetterList) {
 			if (tuple.size() != 2) {
-				throw new IllegalArgumentException("Expected tuple but found " + tuple + "in " + isBetterList);
+				throw new IllegalArgumentException("Expected tuple but found "
+						+ tuple + "in " + isBetterList);
 			}
 			Bid betterbid = bids.get(tuple.get(0));
@@ -133,5 +143,6 @@
 		final int prime = 31;
 		int result = super.hashCode();
-		result = prime * result + ((isBetter == null) ? 0 : isBetter.hashCode());
+		result = prime * result
+				+ ((isBetter == null) ? 0 : isBetter.hashCode());
 		return result;
 	}
Index: /profile/src/main/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilities.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilities.java	(revision 9)
+++ /profile/src/main/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilities.java	(revision 10)
@@ -2,4 +2,5 @@
 
 import java.math.BigDecimal;
+import java.util.Collections;
 import java.util.HashMap;
 import java.util.HashSet;
@@ -68,4 +69,11 @@
 	}
 
+	/**
+	 * @return copy of the value-utility pair map.
+	 */
+	public Map<DiscreteValue, BigDecimal> getUtilities() {
+		return Collections.unmodifiableMap(valueUtilities);
+	}
+
 	@Override
 	public String isFitting(ValueSet valueset) {
Index: /profile/src/main/java/geniusweb/profile/utilityspace/LinearAdditive.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/utilityspace/LinearAdditive.java	(revision 10)
+++ /profile/src/main/java/geniusweb/profile/utilityspace/LinearAdditive.java	(revision 10)
@@ -0,0 +1,29 @@
+package geniusweb.profile.utilityspace;
+
+import java.math.BigDecimal;
+import java.util.Map;
+
+/**
+ * interface to a Utilityspace that is linear-additive.
+ *
+ */
+public interface LinearAdditive extends UtilitySpace {
+	/**
+	 * @return the map from issue names to valuesetutilities (un-weighted)
+	 */
+	Map<String, ValueSetUtilities> getUtilities();
+
+	/**
+	 * 
+	 * @return the map from issue names to weights. weights sum to 1.
+	 */
+	Map<String, BigDecimal> getWeights();
+
+	/**
+	 * 
+	 * @param issue
+	 * @return the weight of the given issue
+	 */
+	BigDecimal getWeight(String issue);
+
+}
Index: /profile/src/main/java/geniusweb/profile/utilityspace/LinearAdditiveUtilitySpace.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/utilityspace/LinearAdditiveUtilitySpace.java	(revision 9)
+++ /profile/src/main/java/geniusweb/profile/utilityspace/LinearAdditiveUtilitySpace.java	(revision 10)
@@ -25,5 +25,5 @@
  */
 @JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
-public class LinearAdditiveUtilitySpace implements UtilitySpace {
+public class LinearAdditiveUtilitySpace implements LinearAdditive {
 
 	private final String name;
@@ -131,16 +131,5 @@
 	}
 
-	/**
-	 * 
-	 * @param issue the issue to get weighted util for
-	 * @param value the issue value to use (typically coming from a bid)
-	 * @return weighted util of just the issue value:
-	 *         issueUtilities[issue].utility(value) * issueWeights[issue)
-	 */
-	private BigDecimal util(String issue, Value value) {
-		return issueWeights.get(issue)
-				.multiply(issueUtilities.get(issue).getUtility(value));
-	}
-
+	@Override
 	public BigDecimal getWeight(String issue) {
 		return issueWeights.get(issue);
@@ -220,18 +209,25 @@
 	}
 
-	/**
-	 * @return the map from issue names to valuesetutilities (un-weighted)
-	 */
+	@Override
 	public Map<String, ValueSetUtilities> getUtilities() {
 		return Collections.unmodifiableMap(issueUtilities);
 	}
 
-	/**
-	 * 
-	 * @return the map from issue names to weights. weights sum to 1.
-	 */
+	@Override
 	public Map<String, BigDecimal> getWeights() {
 		return Collections.unmodifiableMap(issueWeights);
 	}
 
+	/**
+	 * 
+	 * @param issue the issue to get weighted util for
+	 * @param value the issue value to use (typically coming from a bid)
+	 * @return weighted util of just the issue value:
+	 *         issueUtilities[issue].utility(value) * issueWeights[issue)
+	 */
+	private BigDecimal util(String issue, Value value) {
+		return issueWeights.get(issue)
+				.multiply(issueUtilities.get(issue).getUtility(value));
+	}
+
 }
Index: /profile/src/main/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpace.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpace.java	(revision 9)
+++ /profile/src/main/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpace.java	(revision 10)
@@ -84,8 +84,8 @@
 	 * grouping.
 	 * 
-	 * @param las the {@link LinearAdditiveUtilitySpace} to be converted/copied.
-	 * 
-	 */
-	public SumOfGroupsUtilitySpace(LinearAdditiveUtilitySpace las) {
+	 * @param las the {@link LinearAdditive} to be converted/copied.
+	 * 
+	 */
+	public SumOfGroupsUtilitySpace(LinearAdditive las) {
 		this(las.getDomain(), las.getName(), las2parts(las),
 				las.getReservationBid());
@@ -212,10 +212,10 @@
 	/**
 	 * 
-	 * @param las a {@link LinearAdditiveUtilitySpace}
+	 * @param las a {@link LinearAdditive}
 	 * @return a Map with partname-PartsUtilities. The partnames are identical
 	 *         to the issues in the given las.
 	 */
 	private static HashMap<String, PartsUtilities> las2parts(
-			LinearAdditiveUtilitySpace las) {
+			LinearAdditive las) {
 
 		HashMap<String, PartsUtilities> map = new HashMap<>();
Index: /profile/src/test/java/geniusweb/profile/utilityspace/NumberValueSetUtilTest.java
===================================================================
--- /profile/src/test/java/geniusweb/profile/utilityspace/NumberValueSetUtilTest.java	(revision 9)
+++ /profile/src/test/java/geniusweb/profile/utilityspace/NumberValueSetUtilTest.java	(revision 10)
@@ -3,4 +3,5 @@
 import static org.junit.Assert.assertEquals;
 
+import java.io.IOException;
 import java.math.BigDecimal;
 import java.util.Arrays;
@@ -8,4 +9,9 @@
 
 import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
 
 import geniusweb.issuevalue.DiscreteValue;
@@ -35,4 +41,7 @@
 			lowval1, low1util, highvalb, highutil);
 	private static final BigDecimal ZERO_1 = new BigDecimal("0.1");
+	private final String utilstring = "{\"numberutils\":{\"lowValue\":12.5,\"lowUtility\":0.5,\"highValue\":18.5,\"highUtility\":0.9}}";
+
+	private static final ObjectMapper jackson = new ObjectMapper();
 
 	@Override
@@ -173,3 +182,20 @@
 	}
 
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+
+		String json = jackson.writeValueAsString(valueset1);
+		System.out.println(json);
+		assertEquals(utilstring, json);
+	}
+
+	@Test
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		ValueSetUtilities valueutils = jackson.readValue(utilstring,
+				ValueSetUtilities.class);
+		assertEquals(valueset1, valueutils);
+
+	}
+
 }
